package dal

import "goblog/model"

func GetFollowers(uid uint32) (users []model.User, err error) {
	err = db.Select(&users, `SELECT * FROM users WHERE id IN (
		SELECT follower_id FROM following WHERE followee_id=$1
	)`, uid)
	return
}

func AddFollow(followerUid uint32, followeeUid uint32) error {
	_, err := db.Exec(`INSERT OR IGNORE INTO following (follower_id, followee_id)
		VALUES ($1, $2)`, followerUid, followeeUid)
	return err
}

func RemoveFollow(followerUid uint32, followeeUid uint32) error {
	_, err := db.Exec(`DELETE FROM following
		WHERE follower_id=$1 AND followee_id=$2`, followerUid, followeeUid)
	return err
}
