package jwt

import (
	"fmt"
	"github.com/gofiber/fiber/v2"
	"github.com/golang-jwt/jwt/v4"
	"log"
)

var secret []byte

type Data struct {
	Username string `json:"username"`
	UserId   uint32 `json:"uid"`
}

func (j Data) Valid() error {
	return nil
}

func SetJwtKey(key []byte) {
	secret = key
}

func Marshal(claims Data) (token string, err error) {
	log.Println("Login success: ", claims)
	tok := jwt.NewWithClaims(jwt.SigningMethodHS256, claims)
	token, err = tok.SignedString(secret)
	return
}

func GetJwt(c *fiber.Ctx) (data Data, err error) {
	var token *jwt.Token
	token, err = jwt.ParseWithClaims(
		c.Cookies(CookieKey),
		&Data{},
		func(token *jwt.Token) (interface{}, error) {
			return secret, nil
		},
	)
	if err != nil {
		return
	}

	if !token.Valid {
		err = fmt.Errorf("invalid JWT")
		return
	}

	decoded, ok := token.Claims.(*Data)

	if !ok {
		err = fmt.Errorf("invalid JWT object")
		return
	}

	data = *decoded
	return
}
