package main

import (
	"github.com/gofiber/fiber/v2"
	"goblog/controller"
	"goblog/jwt"
	"log"
	"os"
)

var jwtKey []byte

func main() {
	var err error
	jwtKey, err = os.ReadFile("./secret")
	if err != nil {
		log.Fatalf("Failed to read JWT key file: %v\n", err)
	}

	jwt.SetJwtKey(jwtKey)

	app := fiber.New()

	app.Post("/register", controller.Register)
	app.Post("/login", controller.Login)
	app.Post("/logout", controller.Logout)
	app.Post("/follow", controller.Follow)

	app.Get("/is_logged_in", controller.IsLoggedIn)
	app.Get("/posts", controller.Posts)
	app.Get("/profile/:user_id", controller.Profile)

	log.Fatal(app.Listen(":8001"))
}
